{-# LANGUAGE TypeFamilies, MultiParamTypeClasses, FlexibleContexts, RankNTypes #-}

module TypePassing2Test where

import PolyBase
import TypePassing2
import SubTypePassing2

-- map a first order binding time indicator to a function
-- i.e., maps S -> St, D -> Dy


class MBT b where
  type F b :: * -> *
  mbt :: b -> a -> F b a
instance MBT S where
  type F S = St
  mbt _ = St
instance MBT D where
  type F D = Dy
  mbt _ = Dy


-- primitives, conditional

powergen_fo bx0 by0 bz0 x n =
    let bx = mbt bx0
        bn = mbt by0
        bz = mbt bz0
    in
    cIf (bn bool) (bz int)
        (cOp2 (bop2 bn int int bool) oEqInt n (cSub (St int) (bn int) (R 0)))
	(cSub (St int) (bz int) (R 1))
	(cOp2 (bop2 bz int int int) oMult
              (cSub (bx int) (bz int) x)
              (powergen_fo bx0 by0 bz0
               x (cOp2 (bop2 bn int int int) oMinus n (cSub (St int) (bn int) (R 1)))))

powergen :: (CIF bn bz,
	     LE bn bz,
	     CONST
	       (Int -> Int -> Bool)
	       (bn (Con2 (bn Int) (bn (Con2 (bn Int) (bn Bool))))),
	     CAPP bn bn bn,
	     LE bn bn,
	     CONST
	       (Int -> Int -> Int)
	       (bz (Con2 (bz Int) (bz (Con2 (bz Int) (bz Int))))),
	     CAPP bz bz bz,
	     LE bz bz,
             CSUB (St Int) (bn Int) Int,
             CSUB (St Int) (bz Int) Int,
             CSUB (bx Int) (bz Int) Int,
	     CONST
	       (Int -> Int -> Int)
	       (bn (Con2 (bn Int) (bn (Con2 (bn Int) (bn Int))))))
	 => (forall a. a -> bx a) -> (forall a. a -> bn a) -> (forall a. a -> bz a)
         -> R Int (bx Int) -> R Int (bn Int) -> R Int (bz Int)
powergen bx bn bz x n =
    cIf (bn bool) (bz int)
        (cOp2 (bop2 bn int int bool) oEqInt n (cSub (St int) (bn int) (R 0)))
	(cSub (St int) (bz int) (R 1))
	(cOp2 (bop2 bz int int int) oMult
              (cSub (bx int) (bz int) x)
              (powergen bx bn bz
               x (cOp2 (bop2 bn int int int) oMinus n (cSub (St int) (bn int) (R 1)))))

-- primitives, conditional, functions, fix

-- power :: Int -> Int -> Int
-- p :: (Int -> (Int -> Int)) -> (Int -> (Int -> Int))

testpower bx0 bn0 bout0=
  let bx = mbt bx0
      bn = mbt bn0
      bout = mbt bout0
      sfix = (bn (Con2 spow spow)) 
      spow = (bn (Con2 (bx int) spow'))
      spow' = (bn (Con2 (bn int) (bout int)))
      -- bout = lub bx bn
--      _ = le (bx int) (bout int)
--      _ = le (bn int) (bout int)
  in
  cFix sfix $
    cLam sfix $ \p ->
    cLam spow $ \x ->
    cLam spow' $ \n ->
      cIf (bn bool) (bout int)
          (cOp2 (bop2 bn int int bool) oEqInt n (cSub (St int) (bn int) (R 0)))
	  (cSub (St int) (bout int) (R 1))
	  (cOp2 (bop2 bout int int int) oMult
                    (cSub (bx int) (bout int) x)
		    (cApp spow' (cApp spow p x)
			      (cOp2 (bop2 bn int int int) oMinus n (cSub (St int) (bn int) (R 1)))))

tp_ex_01 () = unR (testpower S S S) 2 10
tp_ex_02 () = toString $ unR (testpower D D D)
tp_ex_03 () = toString $ unR (testpower D S D) (EVar"x") 10

-- lists
-- sum :: [Int] -> Int

sum00 bt0 ba0 =
  let bt = mbt bt0
      ba = mbt ba0
      sfix = (bt (Con2 ssum ssum))
      ssum = (bt (Con2 sarg sres))
      sarg = (bt (Con1 (ba int)))
      sres = (ba int)
  in
  cFix sfix
    (cLam sfix (\s ->
     cLam ssum (\l -> 
       cIf (bt bool) sres (cNull sarg l)
		 (cSub (St int) sres (R (0::Int)))
		 (cOp2 (bop2 ba int int int) oPlus (cHead sarg l)
				(cApp ssum s (cTail sarg l))))))

sum_ex_01 () = unR (sum00 S S) []
sum_ex_02 () = unR (sum00 S S) [32, 16, 8]
sum_ex_03 () = toString $ unR (sum00 S D) []
sum_ex_04 () = toString $ unR (sum00 S D) [EVar"x", EVar"y", EVar"z"]
